(ns chat.room
  (:use [clojure.contrib server-socket duck-streams str-utils])
  (:gen-class))


;; CHAT ROOMS

(def rooms (ref {}))

(defn get-room! "Returns the chat room with the given name, creating it if necessary." [name]
  (dosync
   (or (@rooms name)
       (let [new-room (agent '())]
	 (do (alter *rooms* assoc name new-room))))))

(defn say-in-room[room message]
  (doseq [[_ output] room]
    (binding [*out* output]
      (println message))))


;; USERS

(defn user-join[room username output-channel]
  (conj room [username output-channel]))
(defn user-leave[room username]
  (remove #(= (% 0) username) room))


(def *username* "Someone")
(defn- join-room [room]
  (send room user-join *username* *out*)
  (send room 
  )
